/************************************************************************************/
/*  Program name CAPFAEXT_ADDITIONS_B.sql                                           */
/*  Creater:  Karen Nip (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 28 DEC, 2005   Karen Nip         First created                                   */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAEXT_ADDITIONS_B';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFA_ADDITIONS_B.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		*
	FROM
		FA_ADDITIONS_B
	WHERE	SUBSTR(ASSET_NUMBER,1,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.ASSET_ID||CHR(9)||
				C1.ASSET_NUMBER||CHR(9)||
				C1.ASSET_KEY_CCID||CHR(9)||
				C1.CURRENT_UNITS||CHR(9)||
				C1.ASSET_TYPE||CHR(9)||
				C1.TAG_NUMBER||CHR(9)||
				C1.ASSET_CATEGORY_ID||CHR(9)||
				C1.PARENT_ASSET_ID||CHR(9)||
				C1.MANUFACTURER_NAME||CHR(9)||
				C1.SERIAL_NUMBER||CHR(9)||
				C1.MODEL_NUMBER||CHR(9)||
				C1.PROPERTY_TYPE_CODE||CHR(9)||
				C1.PROPERTY_1245_1250_CODE||CHR(9)||
				C1.IN_USE_FLAG||CHR(9)||
				C1.OWNED_LEASED||CHR(9)||
				C1.NEW_USED||CHR(9)||
				C1.UNIT_ADJUSTMENT_FLAG||CHR(9)||
				C1.ADD_COST_JE_FLAG||CHR(9)||
				C1.ATTRIBUTE1||CHR(9)||
				C1.ATTRIBUTE2||CHR(9)||
				C1.ATTRIBUTE3||CHR(9)||
				C1.ATTRIBUTE4||CHR(9)||
				C1.ATTRIBUTE5||CHR(9)||
				C1.ATTRIBUTE6||CHR(9)||
				C1.ATTRIBUTE7||CHR(9)||
				C1.ATTRIBUTE8||CHR(9)||
				C1.ATTRIBUTE9||CHR(9)||
				C1.ATTRIBUTE10||CHR(9)||
				C1.ATTRIBUTE11||CHR(9)||
				C1.ATTRIBUTE12||CHR(9)||
				C1.ATTRIBUTE13||CHR(9)||
				C1.ATTRIBUTE14||CHR(9)||
				C1.ATTRIBUTE15||CHR(9)||
				C1.ATTRIBUTE16||CHR(9)||
				C1.ATTRIBUTE17||CHR(9)||
				C1.ATTRIBUTE18||CHR(9)||
				C1.ATTRIBUTE19||CHR(9)||
				C1.ATTRIBUTE20||CHR(9)||
				C1.ATTRIBUTE21||CHR(9)||
				C1.ATTRIBUTE22||CHR(9)||
				C1.ATTRIBUTE23||CHR(9)||
				C1.ATTRIBUTE24||CHR(9)||
				C1.ATTRIBUTE25||CHR(9)||
				C1.ATTRIBUTE26||CHR(9)||
				C1.ATTRIBUTE27||CHR(9)||
				C1.ATTRIBUTE28||CHR(9)||
				C1.ATTRIBUTE29||CHR(9)||
				C1.ATTRIBUTE30||CHR(9)||
				C1.ATTRIBUTE_CATEGORY_CODE||CHR(9)||
				C1.CONTEXT||CHR(9)||
				C1.LEASE_ID||CHR(9)||
				C1.INVENTORIAL||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
				C1.LAST_UPDATED_BY||CHR(9)||
				C1.CREATED_BY||CHR(9)||
				C1.CREATION_DATE||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
				C1.GLOBAL_ATTRIBUTE1||CHR(9)||
				C1.GLOBAL_ATTRIBUTE2||CHR(9)||
				C1.GLOBAL_ATTRIBUTE3||CHR(9)||
				C1.GLOBAL_ATTRIBUTE4||CHR(9)||
				C1.GLOBAL_ATTRIBUTE5||CHR(9)||
				C1.GLOBAL_ATTRIBUTE6||CHR(9)||
				C1.GLOBAL_ATTRIBUTE7||CHR(9)||
				C1.GLOBAL_ATTRIBUTE8||CHR(9)||
				C1.GLOBAL_ATTRIBUTE9||CHR(9)||
				C1.GLOBAL_ATTRIBUTE10||CHR(9)||
				C1.GLOBAL_ATTRIBUTE11||CHR(9)||
				C1.GLOBAL_ATTRIBUTE12||CHR(9)||
				C1.GLOBAL_ATTRIBUTE13||CHR(9)||
				C1.GLOBAL_ATTRIBUTE14||CHR(9)||
				C1.GLOBAL_ATTRIBUTE15||CHR(9)||
				C1.GLOBAL_ATTRIBUTE16||CHR(9)||
				C1.GLOBAL_ATTRIBUTE17||CHR(9)||
				C1.GLOBAL_ATTRIBUTE18||CHR(9)||
				C1.GLOBAL_ATTRIBUTE19||CHR(9)||
				C1.GLOBAL_ATTRIBUTE20||CHR(9)||
				C1.GLOBAL_ATTRIBUTE_CATEGORY||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/